/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSAccessibility_bindings;

import dstep.appkit.AppKitDefines;
import dstep.foundation.NSArray;
import dstep.appkit.NSErrors;
import dstep.foundation.NSString;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;


extern (C)
{
	extern
	{
		package const id NSAccessibilityErrorCodeExceptionInfo;
		package const id NSAccessibilityRoleAttribute;
		package const id NSAccessibilityRoleDescriptionAttribute;
		package const id NSAccessibilitySubroleAttribute;
		package const id NSAccessibilityHelpAttribute;
		package const id NSAccessibilityValueAttribute;
		package const id NSAccessibilityMinValueAttribute;
		package const id NSAccessibilityMaxValueAttribute;
		package const id NSAccessibilityEnabledAttribute;
		package const id NSAccessibilityFocusedAttribute;
		package const id NSAccessibilityParentAttribute;
		package const id NSAccessibilityChildrenAttribute;
		package const id NSAccessibilityWindowAttribute;
		package const id NSAccessibilityTopLevelUIElementAttribute;
		package const id NSAccessibilitySelectedChildrenAttribute;
		package const id NSAccessibilityVisibleChildrenAttribute;
		package const id NSAccessibilityPositionAttribute;
		package const id NSAccessibilitySizeAttribute;
		package const id NSAccessibilityContentsAttribute;
		package const id NSAccessibilityTitleAttribute;
		package const id NSAccessibilityDescriptionAttribute;
		package const id NSAccessibilityShownMenuAttribute;
		package const id NSAccessibilityValueDescriptionAttribute;
		package const id NSAccessibilityPreviousContentsAttribute;
		package const id NSAccessibilityNextContentsAttribute;
		package const id NSAccessibilityHeaderAttribute;
		package const id NSAccessibilityEditedAttribute;
		package const id NSAccessibilityTabsAttribute;
		package const id NSAccessibilityHorizontalScrollBarAttribute;
		package const id NSAccessibilityVerticalScrollBarAttribute;
		package const id NSAccessibilityOverflowButtonAttribute;
		package const id NSAccessibilityIncrementButtonAttribute;
		package const id NSAccessibilityDecrementButtonAttribute;
		package const id NSAccessibilityFilenameAttribute;
		package const id NSAccessibilityExpandedAttribute;
		package const id NSAccessibilitySelectedAttribute;
		package const id NSAccessibilitySplittersAttribute;
		package const id NSAccessibilityDocumentAttribute;
		package const id NSAccessibilityURLAttribute;
		package const id NSAccessibilityIndexAttribute;
		package const id NSAccessibilityRowCountAttribute;
		package const id NSAccessibilityColumnCountAttribute;
		package const id NSAccessibilityOrderedByRowAttribute;
		package const id NSAccessibilityTitleUIElementAttribute;
		package const id NSAccessibilityServesAsTitleForUIElementsAttribute;
		package const id NSAccessibilityLinkedUIElementsAttribute;
		package const id NSAccessibilitySelectedTextAttribute;
		package const id NSAccessibilitySelectedTextRangeAttribute;
		package const id NSAccessibilityNumberOfCharactersAttribute;
		package const id NSAccessibilityVisibleCharacterRangeAttribute;
		package const id NSAccessibilitySharedTextUIElementsAttribute;
		package const id NSAccessibilitySharedCharacterRangeAttribute;
		package const id NSAccessibilityInsertionPointLineNumberAttribute;
		package const id NSAccessibilitySelectedTextRangesAttribute;
		package const id NSAccessibilityLineForIndexParameterizedAttribute;
		package const id NSAccessibilityRangeForLineParameterizedAttribute;
		package const id NSAccessibilityStringForRangeParameterizedAttribute;
		package const id NSAccessibilityRangeForPositionParameterizedAttribute;
		package const id NSAccessibilityRangeForIndexParameterizedAttribute;
		package const id NSAccessibilityBoundsForRangeParameterizedAttribute;
		package const id NSAccessibilityRTFForRangeParameterizedAttribute;
		package const id NSAccessibilityStyleRangeForIndexParameterizedAttribute;
		package const id NSAccessibilityAttributedStringForRangeParameterizedAttribute;
		package const id NSAccessibilityFontTextAttribute;
		package const id NSAccessibilityForegroundColorTextAttribute;
		package const id NSAccessibilityBackgroundColorTextAttribute;
		package const id NSAccessibilityUnderlineColorTextAttribute;
		package const id NSAccessibilityStrikethroughColorTextAttribute;
		package const id NSAccessibilityUnderlineTextAttribute;
		package const id NSAccessibilitySuperscriptTextAttribute;
		package const id NSAccessibilityStrikethroughTextAttribute;
		package const id NSAccessibilityShadowTextAttribute;
		package const id NSAccessibilityAttachmentTextAttribute;
		package const id NSAccessibilityLinkTextAttribute;
		package const id NSAccessibilityMisspelledTextAttribute;
		package const id NSAccessibilityFontNameKey;
		package const id NSAccessibilityFontFamilyKey;
		package const id NSAccessibilityVisibleNameKey;
		package const id NSAccessibilityFontSizeKey;
		package const id NSAccessibilityMainAttribute;
		package const id NSAccessibilityMinimizedAttribute;
		package const id NSAccessibilityCloseButtonAttribute;
		package const id NSAccessibilityZoomButtonAttribute;
		package const id NSAccessibilityMinimizeButtonAttribute;
		package const id NSAccessibilityToolbarButtonAttribute;
		package const id NSAccessibilityProxyAttribute;
		package const id NSAccessibilityGrowAreaAttribute;
		package const id NSAccessibilityModalAttribute;
		package const id NSAccessibilityDefaultButtonAttribute;
		package const id NSAccessibilityCancelButtonAttribute;
		package const id NSAccessibilityMenuBarAttribute;
		package const id NSAccessibilityWindowsAttribute;
		package const id NSAccessibilityFrontmostAttribute;
		package const id NSAccessibilityHiddenAttribute;
		package const id NSAccessibilityMainWindowAttribute;
		package const id NSAccessibilityFocusedWindowAttribute;
		package const id NSAccessibilityFocusedUIElementAttribute;
		package const id NSAccessibilityOrientationAttribute;
		package const id NSAccessibilityVerticalOrientationValue;
		package const id NSAccessibilityHorizontalOrientationValue;
		package const id NSAccessibilityColumnTitlesAttribute;
		package const id NSAccessibilitySearchButtonAttribute;
		package const id NSAccessibilitySearchMenuAttribute;
		package const id NSAccessibilityClearButtonAttribute;
		package const id NSAccessibilityRowsAttribute;
		package const id NSAccessibilityVisibleRowsAttribute;
		package const id NSAccessibilitySelectedRowsAttribute;
		package const id NSAccessibilityColumnsAttribute;
		package const id NSAccessibilityVisibleColumnsAttribute;
		package const id NSAccessibilitySelectedColumnsAttribute;
		package const id NSAccessibilitySortDirectionAttribute;
		package const id NSAccessibilityAscendingSortDirectionValue;
		package const id NSAccessibilityDescendingSortDirectionValue;
		package const id NSAccessibilityUnknownSortDirectionValue;
		package const id NSAccessibilityDisclosingAttribute;
		package const id NSAccessibilityDisclosedRowsAttribute;
		package const id NSAccessibilityDisclosedByRowAttribute;
		package const id NSAccessibilityDisclosureLevelAttribute;
		package const id NSAccessibilityAllowedValuesAttribute;
		package const id NSAccessibilityLabelUIElementsAttribute;
		package const id NSAccessibilityLabelValueAttribute;
		package const id NSAccessibilityMatteHoleAttribute;
		package const id NSAccessibilityMatteContentUIElementAttribute;
		package const id NSAccessibilityMarkerUIElementsAttribute;
		package const id NSAccessibilityMarkerValuesAttribute;
		package const id NSAccessibilityMarkerGroupUIElementAttribute;
		package const id NSAccessibilityUnitsAttribute;
		package const id NSAccessibilityUnitDescriptionAttribute;
		package const id NSAccessibilityMarkerTypeAttribute;
		package const id NSAccessibilityMarkerTypeDescriptionAttribute;
		package const id NSAccessibilityLeftTabStopMarkerTypeValue;
		package const id NSAccessibilityRightTabStopMarkerTypeValue;
		package const id NSAccessibilityCenterTabStopMarkerTypeValue;
		package const id NSAccessibilityDecimalTabStopMarkerTypeValue;
		package const id NSAccessibilityHeadIndentMarkerTypeValue;
		package const id NSAccessibilityTailIndentMarkerTypeValue;
		package const id NSAccessibilityFirstLineIndentMarkerTypeValue;
		package const id NSAccessibilityUnknownMarkerTypeValue;
		package const id NSAccessibilityInchesUnitValue;
		package const id NSAccessibilityCentimetersUnitValue;
		package const id NSAccessibilityPointsUnitValue;
		package const id NSAccessibilityPicasUnitValue;
		package const id NSAccessibilityUnknownUnitValue;
		package const id NSAccessibilityPressAction;
		package const id NSAccessibilityIncrementAction;
		package const id NSAccessibilityDecrementAction;
		package const id NSAccessibilityConfirmAction;
		package const id NSAccessibilityPickAction;
		package const id NSAccessibilityCancelAction;
		package const id NSAccessibilityRaiseAction;
		package const id NSAccessibilityShowMenuAction;
		package const id NSAccessibilityDeleteAction;
		package const id NSAccessibilityMainWindowChangedNotification;
		package const id NSAccessibilityFocusedWindowChangedNotification;
		package const id NSAccessibilityFocusedUIElementChangedNotification;
		package const id NSAccessibilityApplicationActivatedNotification;
		package const id NSAccessibilityApplicationDeactivatedNotification;
		package const id NSAccessibilityApplicationHiddenNotification;
		package const id NSAccessibilityApplicationShownNotification;
		package const id NSAccessibilityWindowCreatedNotification;
		package const id NSAccessibilityWindowMovedNotification;
		package const id NSAccessibilityWindowResizedNotification;
		package const id NSAccessibilityWindowMiniaturizedNotification;
		package const id NSAccessibilityWindowDeminiaturizedNotification;
		package const id NSAccessibilityDrawerCreatedNotification;
		package const id NSAccessibilitySheetCreatedNotification;
		package const id NSAccessibilityUIElementDestroyedNotification;
		package const id NSAccessibilityValueChangedNotification;
		package const id NSAccessibilityTitleChangedNotification;
		package const id NSAccessibilityResizedNotification;
		package const id NSAccessibilityMovedNotification;
		package const id NSAccessibilityCreatedNotification;
		package const id NSAccessibilityHelpTagCreatedNotification;
		package const id NSAccessibilitySelectedTextChangedNotification;
		package const id NSAccessibilityRowCountChangedNotification;
		package const id NSAccessibilitySelectedChildrenChangedNotification;
		package const id NSAccessibilitySelectedRowsChangedNotification;
		package const id NSAccessibilitySelectedColumnsChangedNotification;
		package const id NSAccessibilityUnknownRole;
		package const id NSAccessibilityButtonRole;
		package const id NSAccessibilityRadioButtonRole;
		package const id NSAccessibilityCheckBoxRole;
		package const id NSAccessibilitySliderRole;
		package const id NSAccessibilityTabGroupRole;
		package const id NSAccessibilityTextFieldRole;
		package const id NSAccessibilityStaticTextRole;
		package const id NSAccessibilityTextAreaRole;
		package const id NSAccessibilityScrollAreaRole;
		package const id NSAccessibilityPopUpButtonRole;
		package const id NSAccessibilityMenuButtonRole;
		package const id NSAccessibilityTableRole;
		package const id NSAccessibilityApplicationRole;
		package const id NSAccessibilityGroupRole;
		package const id NSAccessibilityRadioGroupRole;
		package const id NSAccessibilityListRole;
		package const id NSAccessibilityScrollBarRole;
		package const id NSAccessibilityValueIndicatorRole;
		package const id NSAccessibilityImageRole;
		package const id NSAccessibilityMenuBarRole;
		package const id NSAccessibilityMenuRole;
		package const id NSAccessibilityMenuItemRole;
		package const id NSAccessibilityColumnRole;
		package const id NSAccessibilityRowRole;
		package const id NSAccessibilityToolbarRole;
		package const id NSAccessibilityBusyIndicatorRole;
		package const id NSAccessibilityProgressIndicatorRole;
		package const id NSAccessibilityWindowRole;
		package const id NSAccessibilityDrawerRole;
		package const id NSAccessibilitySystemWideRole;
		package const id NSAccessibilityOutlineRole;
		package const id NSAccessibilityIncrementorRole;
		package const id NSAccessibilityBrowserRole;
		package const id NSAccessibilityComboBoxRole;
		package const id NSAccessibilitySplitGroupRole;
		package const id NSAccessibilitySplitterRole;
		package const id NSAccessibilityColorWellRole;
		package const id NSAccessibilityGrowAreaRole;
		package const id NSAccessibilitySheetRole;
		package const id NSAccessibilityHelpTagRole;
		package const id NSAccessibilityMatteRole;
		package const id NSAccessibilityRulerRole;
		package const id NSAccessibilityRulerMarkerRole;
		package const id NSAccessibilitySortButtonRole;
		package const id NSAccessibilityLinkRole;
		package const id NSAccessibilityDisclosureTriangleRole;
		package const id NSAccessibilityGridRole;
		package const id NSAccessibilityUnknownSubrole;
		package const id NSAccessibilityCloseButtonSubrole;
		package const id NSAccessibilityZoomButtonSubrole;
		package const id NSAccessibilityMinimizeButtonSubrole;
		package const id NSAccessibilityToolbarButtonSubrole;
		package const id NSAccessibilityTableRowSubrole;
		package const id NSAccessibilityOutlineRowSubrole;
		package const id NSAccessibilitySecureTextFieldSubrole;
		package const id NSAccessibilityStandardWindowSubrole;
		package const id NSAccessibilityDialogSubrole;
		package const id NSAccessibilitySystemDialogSubrole;
		package const id NSAccessibilityFloatingWindowSubrole;
		package const id NSAccessibilitySystemFloatingWindowSubrole;
		package const id NSAccessibilityIncrementArrowSubrole;
		package const id NSAccessibilityDecrementArrowSubrole;
		package const id NSAccessibilityIncrementPageSubrole;
		package const id NSAccessibilityDecrementPageSubrole;
		package const id NSAccessibilitySearchFieldSubrole;
		package const id NSAccessibilityTextAttachmentSubrole;
		package const id NSAccessibilityTextLinkSubrole;
		package const id NSAccessibilityTimelineSubrole;
	}
}

extern (C)
{
	package id NSAccessibilityRoleDescription (id role, id subrole);
	package id NSAccessibilityRoleDescriptionForUIElement (id element);
	package id NSAccessibilityActionDescription (id action);
	package void NSAccessibilityRaiseBadArgumentException (id element, id attribute, id value);
	package id NSAccessibilityUnignoredAncestor (id element);
	package id NSAccessibilityUnignoredDescendant (id element);
	package id NSAccessibilityUnignoredChildren (id originalChildren);
	package id NSAccessibilityUnignoredChildrenForOnlyChild (id originalChild);
	package void NSAccessibilityPostNotification (id element, id notification);
}