/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSCIImageRep;

import dstep.appkit.NSBitmapImageRep;
import dstep.appkit.NSGraphics;
import dstep.appkit.NSImageRep;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CIImage;

class NSCIImageRep : NSImageRep
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static Object imageRepWithCIImage (CIImage image)
	{
		return invokeObjcSelfClass!(Object, "imageRepWithCIImage:", CIImage)(image);
	}

	NSCIImageRep initWithCIImage (CIImage image)
	{
		id result = invokeObjcSelf!(id, "initWithCIImage:", CIImage)(image);
		return result is this.objcObject ? this : (result !is null ? new NSCIImageRep(result) : null);
	}

	this (CIImage image)
	{
		super(NSCIImageRep.alloc.initWithCIImage(image).objcObject);
	}

	CIImage CIImage_ ()
	{
		return invokeObjcSelf!(CIImage, "CIImage");
	}
}

