/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSMenuItemCell;

import dstep.appkit.NSButtonCell;
import dstep.appkit.NSMenu;
import dstep.appkit.NSMenuItem;
import dstep.appkit.NSMenuView;
import dstep.appkit.NSView;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSMenuItemCell : NSButtonCell
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	void setMenuItem (NSMenuItem item)
	{
		return invokeObjcSelf!(void, "setMenuItem:", NSMenuItem)(item);
	}

	NSMenuItem menuItem ()
	{
		return invokeObjcSelf!(NSMenuItem, "menuItem");
	}

	void setNeedsSizing (bool flag)
	{
		return invokeObjcSelf!(void, "setNeedsSizing:", bool)(flag);
	}

	bool needsSizing ()
	{
		return invokeObjcSelf!(bool, "needsSizing");
	}

	void calcSize ()
	{
		return invokeObjcSelf!(void, "calcSize");
	}

	void setNeedsDisplay (bool flag)
	{
		return invokeObjcSelf!(void, "setNeedsDisplay:", bool)(flag);
	}

	bool needsDisplay ()
	{
		return invokeObjcSelf!(bool, "needsDisplay");
	}

	CGFloat stateImageWidth ()
	{
		return invokeObjcSelf!(CGFloat, "stateImageWidth");
	}

	CGFloat imageWidth ()
	{
		return invokeObjcSelf!(CGFloat, "imageWidth");
	}

	CGFloat titleWidth ()
	{
		return invokeObjcSelf!(CGFloat, "titleWidth");
	}

	CGFloat keyEquivalentWidth ()
	{
		return invokeObjcSelf!(CGFloat, "keyEquivalentWidth");
	}

	NSRect stateImageRectForBounds (NSRect cellFrame)
	{
		return invokeObjcSelf!(NSRect, "stateImageRectForBounds:", NSRect)(cellFrame);
	}

	NSRect titleRectForBounds (NSRect cellFrame)
	{
		return invokeObjcSelf!(NSRect, "titleRectForBounds:", NSRect)(cellFrame);
	}

	NSRect keyEquivalentRectForBounds (NSRect cellFrame)
	{
		return invokeObjcSelf!(NSRect, "keyEquivalentRectForBounds:", NSRect)(cellFrame);
	}

	void drawSeparatorItemWithFrame (NSRect cellFrame, NSView controlView)
	{
		return invokeObjcSelf!(void, "drawSeparatorItemWithFrame:inView:", NSRect, NSView)(cellFrame, controlView);
	}

	void drawStateImageWithFrame (NSRect cellFrame, NSView controlView)
	{
		return invokeObjcSelf!(void, "drawStateImageWithFrame:inView:", NSRect, NSView)(cellFrame, controlView);
	}

	void drawImageWithFrame (NSRect cellFrame, NSView controlView)
	{
		return invokeObjcSelf!(void, "drawImageWithFrame:inView:", NSRect, NSView)(cellFrame, controlView);
	}

	void drawTitleWithFrame (NSRect cellFrame, NSView controlView)
	{
		return invokeObjcSelf!(void, "drawTitleWithFrame:inView:", NSRect, NSView)(cellFrame, controlView);
	}

	void drawKeyEquivalentWithFrame (NSRect cellFrame, NSView controlView)
	{
		return invokeObjcSelf!(void, "drawKeyEquivalentWithFrame:inView:", NSRect, NSView)(cellFrame, controlView);
	}

	void drawBorderAndBackgroundWithFrame (NSRect cellFrame, NSView controlView)
	{
		return invokeObjcSelf!(void, "drawBorderAndBackgroundWithFrame:inView:", NSRect, NSView)(cellFrame, controlView);
	}

	NSInteger tag ()
	{
		return invokeObjcSelf!(NSInteger, "tag");
	}
}

