/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSToolbarItemGroup;

import dstep.appkit.AppKit;
import dstep.appkit.NSToolbarItem;
import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSToolbarItemGroup : NSToolbarItem
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	void setSubitems (NSArray subitems)
	{
		return invokeObjcSelf!(void, "setSubitems:", NSArray)(subitems);
	}

	NSArray subitems ()
	{
		return invokeObjcSelf!(NSArray, "subitems");
	}
}

