/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFContext;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFURL;

import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGContext;
import dstep.applicationservices.coregraphics.CGDataConsumer;
import dstep.applicationservices.coregraphics.CGGeometry;

extern (C)
{
	extern
	{
		const CFStringRef kCGPDFContextMediaBox;
		const CFStringRef kCGPDFContextCropBox;
		const CFStringRef kCGPDFContextBleedBox;
		const CFStringRef kCGPDFContextTrimBox;
		const CFStringRef kCGPDFContextArtBox;
		const CFStringRef kCGPDFContextTitle;
		const CFStringRef kCGPDFContextAuthor;
		const CFStringRef kCGPDFContextSubject;
		const CFStringRef kCGPDFContextKeywords;
		const CFStringRef kCGPDFContextCreator;
		const CFStringRef kCGPDFContextOwnerPassword;
		const CFStringRef kCGPDFContextUserPassword;
		const CFStringRef kCGPDFContextEncryptionKeyLength;
		const CFStringRef kCGPDFContextAllowsPrinting;
		const CFStringRef kCGPDFContextAllowsCopying;
		const CFStringRef kCGPDFContextOutputIntent;
		const CFStringRef kCGPDFXOutputIntentSubtype;
		const CFStringRef kCGPDFXOutputConditionIdentifier;
		const CFStringRef kCGPDFXOutputCondition;
		const CFStringRef kCGPDFXRegistryName;
		const CFStringRef kCGPDFXInfo;
		const CFStringRef kCGPDFXDestinationOutputProfile;
		const CFStringRef kCGPDFContextOutputIntents;
	}
}

extern (C)
{
	CGContextRef CGPDFContextCreate (CGDataConsumerRef consumer, CGRect* mediaBox, CFDictionaryRef auxiliaryInfo);
	CGContextRef CGPDFContextCreateWithURL (CFURLRef url, CGRect* mediaBox, CFDictionaryRef auxiliaryInfo);
	void CGPDFContextClose (CGContextRef context);
	void CGPDFContextBeginPage (CGContextRef context, CFDictionaryRef pageInfo);
	void CGPDFContextEndPage (CGContextRef context);
	void CGPDFContextSetURLForRect (CGContextRef context, CFURLRef url, CGRect rect);
	void CGPDFContextAddDestinationAtPoint (CGContextRef context, CFStringRef name, CGPoint point);
	void CGPDFContextSetDestinationForRect (CGContextRef context, CFStringRef name, CGRect rect);
}