/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSManagedObjectID;

import dstep.coredata.NSEntityDescription;
import dstep.coredata.NSPersistentStore;
import dstep.foundation.NSObject;
import dstep.foundation.NSURL;
import dstep.foundation.NSZone;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSManagedObjectID : NSObject, INSCopying
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSEntityDescription entity ()
	{
		return invokeObjcSelf!(NSEntityDescription, "entity");
	}

	NSPersistentStore persistentStore ()
	{
		return invokeObjcSelf!(NSPersistentStore, "persistentStore");
	}

	bool isTemporaryID ()
	{
		return invokeObjcSelf!(bool, "isTemporaryID");
	}

	NSURL URIRepresentation ()
	{
		return invokeObjcSelf!(NSURL, "URIRepresentation");
	}
	
	typeof(this) copyWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(typeof(this), "copyWithZone:", NSZone*)(zone);
	}
}

