/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSProcessInfo;

import dstep.foundation.NSArray;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

enum
{
	NSWindowsNTOperatingSystem = 1,
	NSWindows95OperatingSystem,
	NSSolarisOperatingSystem,
	NSHPUXOperatingSystem,
	NSMACHOperatingSystem,
	NSSunOSOperatingSystem,
	NSOSF1OperatingSystem
}

class NSProcessInfo : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSProcessInfo processInfo ()
	{
		return invokeObjcSuperClass!(NSProcessInfo, "processInfo");
	}

	NSDictionary environment ()
	{
		return invokeObjcSelf!(NSDictionary, "environment");
	}

	NSArray arguments ()
	{
		return invokeObjcSelf!(NSArray, "arguments");
	}

	NSString hostName ()
	{
		return invokeObjcSelf!(NSString, "hostName");
	}

	NSString processName ()
	{
		return invokeObjcSelf!(NSString, "processName");
	}

	int processIdentifier ()
	{
		return invokeObjcSelf!(int, "processIdentifier");
	}

	void setProcessName (NSString newName)
	{
		return invokeObjcSelf!(void, "setProcessName:", NSString)(newName);
	}

	NSString globallyUniqueString ()
	{
		return invokeObjcSelf!(NSString, "globallyUniqueString");
	}

	NSUInteger operatingSystem ()
	{
		return invokeObjcSelf!(NSUInteger, "operatingSystem");
	}

	NSString operatingSystemName ()
	{
		return invokeObjcSelf!(NSString, "operatingSystemName");
	}

	NSString operatingSystemVersionString ()
	{
		return invokeObjcSelf!(NSString, "operatingSystemVersionString");
	}

	NSUInteger processorCount ()
	{
		return invokeObjcSelf!(NSUInteger, "processorCount");
	}

	NSUInteger activeProcessorCount ()
	{
		return invokeObjcSelf!(NSUInteger, "activeProcessorCount");
	}

	ulong physicalMemory ()
	{
		return invokeObjcSelf!(ulong, "physicalMemory");
	}
}

