/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSScriptCoercionHandler;

import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSScriptCoercionHandler : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSScriptCoercionHandler sharedCoercionHandler ()
	{
		return invokeObjcSuperClass!(NSScriptCoercionHandler, "sharedCoercionHandler");
	}

	Object coerceValue (Object value, Class toClass)
	{
		return invokeObjcSelf!(Object, "coerceValue:toClass:", Object, Class)(value, toClass);
	}

	void registerCoercer (Object coercer, SEL selector, Class fromClass, Class toClass)
	{
		return invokeObjcSelf!(void, "registerCoercer:selector:toConvertFromClass:toClass:", Object, SEL, Class, Class)(coercer, selector, fromClass, toClass);
	}
}

