/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSScriptSuiteRegistry;

import dstep.foundation.NSArray;
import dstep.foundation.NSBundle;
import dstep.foundation.NSData;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.foundation.NSScriptClassDescription;
import dstep.foundation.NSScriptCommandDescription;
import dstep.foundation.NSSet;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSScriptSuiteRegistry : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSScriptSuiteRegistry sharedScriptSuiteRegistry ()
	{
		return invokeObjcSuperClass!(NSScriptSuiteRegistry, "sharedScriptSuiteRegistry");
	}

	static void setSharedScriptSuiteRegistry (NSScriptSuiteRegistry registry)
	{
		return invokeObjcSuperClass!(void, "setSharedScriptSuiteRegistry:", NSScriptSuiteRegistry)(registry);
	}

	void loadSuitesFromBundle (NSBundle bundle)
	{
		return invokeObjcSelf!(void, "loadSuitesFromBundle:", NSBundle)(bundle);
	}

	void loadSuiteWithDictionary (NSDictionary suiteDeclaration, NSBundle bundle)
	{
		return invokeObjcSelf!(void, "loadSuiteWithDictionary:fromBundle:", NSDictionary, NSBundle)(suiteDeclaration, bundle);
	}

	void registerClassDescription (NSScriptClassDescription classDescription)
	{
		return invokeObjcSelf!(void, "registerClassDescription:", NSScriptClassDescription)(classDescription);
	}

	void registerCommandDescription (NSScriptCommandDescription commandDescription)
	{
		return invokeObjcSelf!(void, "registerCommandDescription:", NSScriptCommandDescription)(commandDescription);
	}

	NSArray suiteNames ()
	{
		return invokeObjcSelf!(NSArray, "suiteNames");
	}

	uint appleEventCodeForSuite (NSString suiteName)
	{
		return invokeObjcSelf!(uint, "appleEventCodeForSuite:", NSString)(suiteName);
	}

	NSBundle bundleForSuite (NSString suiteName)
	{
		return invokeObjcSelf!(NSBundle, "bundleForSuite:", NSString)(suiteName);
	}

	NSDictionary classDescriptionsInSuite (NSString suiteName)
	{
		return invokeObjcSelf!(NSDictionary, "classDescriptionsInSuite:", NSString)(suiteName);
	}

	NSDictionary commandDescriptionsInSuite (NSString suiteName)
	{
		return invokeObjcSelf!(NSDictionary, "commandDescriptionsInSuite:", NSString)(suiteName);
	}

	NSString suiteForAppleEventCode (uint appleEventCode)
	{
		return invokeObjcSelf!(NSString, "suiteForAppleEventCode:", uint)(appleEventCode);
	}

	NSScriptClassDescription classDescriptionWithAppleEventCode (uint appleEventCode)
	{
		return invokeObjcSelf!(NSScriptClassDescription, "classDescriptionWithAppleEventCode:", uint)(appleEventCode);
	}

	NSScriptCommandDescription commandDescriptionWithAppleEventClass (uint appleEventClassCode, uint appleEventIDCode)
	{
		return invokeObjcSelf!(NSScriptCommandDescription, "commandDescriptionWithAppleEventClass:andAppleEventCode:", uint, uint)(appleEventClassCode, appleEventIDCode);
	}

	NSData aeteResource (NSString languageName)
	{
		return invokeObjcSelf!(NSData, "aeteResource:", NSString)(languageName);
	}
}

