/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTCaptureDeviceInput;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTCaptureDevice;
import dstep.qtkit.QTCaptureInput;
import dstep.qtkit.QTKitDefines;

class QTCaptureDeviceInput : QTCaptureInput
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static Object deviceInputWithDevice (QTCaptureDevice device)
	{
		return invokeObjcSelfClass!(Object, "deviceInputWithDevice:", QTCaptureDevice)(device);
	}

	QTCaptureDeviceInput initWithDevice (QTCaptureDevice device)
	{
		id result = invokeObjcSelf!(id, "initWithDevice:", QTCaptureDevice)(device);
		return result is this.objcObject ? this : (result !is null ? new QTCaptureDeviceInput(result) : null);
	}

	this (QTCaptureDevice device)
	{
		super(QTCaptureDeviceInput.alloc.initWithDevice(device).objcObject);
	}

	QTCaptureDevice device ()
	{
		return invokeObjcSelf!(QTCaptureDevice, "device");
	}
}

