/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTCaptureLayer;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTCaptureSession;
import dstep.qtkit.QTKitDefines;
import dstep.quartzcore.CALayer;
import dstep.quartzcore.QuartzCore;

class QTCaptureLayer : CALayer
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static Object layerWithSession (QTCaptureSession session)
	{
		return invokeObjcSelfClass!(Object, "layerWithSession:", QTCaptureSession)(session);
	}

	QTCaptureLayer initWithSession (QTCaptureSession session)
	{
		id result = invokeObjcSelf!(id, "initWithSession:", QTCaptureSession)(session);
		return result is this.objcObject ? this : (result !is null ? new QTCaptureLayer(result) : null);
	}

	this (QTCaptureSession session)
	{
		super(QTCaptureLayer.alloc.initWithSession(session).objcObject);
	}

	void setSession (QTCaptureSession session)
	{
		return invokeObjcSelf!(void, "setSession:", QTCaptureSession)(session);
	}

	QTCaptureSession session ()
	{
		return invokeObjcSelf!(QTCaptureSession, "session");
	}
}

