/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTMovieLayer;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTKitDefines;
import dstep.qtkit.QTMovie;
import dstep.quartzcore.CALayer;

class QTMovieLayer : CALayer
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static Object layerWithMovie (QTMovie movie)
	{
		return invokeObjcSelfClass!(Object, "layerWithMovie:", QTMovie)(movie);
	}

	QTMovieLayer initWithMovie (QTMovie movie)
	{
		id result = invokeObjcSelf!(id, "initWithMovie:", QTMovie)(movie);
		return result is this.objcObject ? this : (result !is null ? new QTMovieLayer(result) : null);
	}

	this (QTMovie movie)
	{
		super(QTMovieLayer.alloc.initWithMovie(movie).objcObject);
	}

	void setMovie (QTMovie movie)
	{
		return invokeObjcSelf!(void, "setMovie:", QTMovie)(movie);
	}

	QTMovie movie ()
	{
		return invokeObjcSelf!(QTMovie, "movie");
	}
}

