/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.cssmtpi;

import dstep.security.cssmtype;

struct CSSM_SPI_TP_FUNCS
{
	CSSM_TP_AUTHORITY_ID* PreferredAuthority;
	uint RequestType;
	CSSM_TP_REQUEST_SET* RequestInput;
	CSSM_TP_CALLERAUTH_CONTEXT* CallerAuthContext;
	int* EstimatedTime;
	CSSM_DATA* ReferenceIdentifier;
	CSSM_TP_CALLERAUTH_CONTEXT* CallerAuthCredentials;
	CSSM_BOOL* ConfirmationRequired;
	CSSM_TP_CONFIRM_RESPONSE* Responses;
	CSSM_CERTGROUP* CertGroup;
	uint CertIndex;
	ulong KeyCacheHandle;
	int CSPHandle;
	uint FormType;
	CSSM_DATA* Form;
	CSSM_TP_AUTHORITY_ID* ClearanceAuthority;
	CSSM_TP_AUTHORITY_ID* RepresentedAuthority;
	int CLHandle;
	CSSM_CERTGROUP* CertGroupToBeVerified;
	CSSM_TP_VERIFY_CONTEXT* VerifyContext;
	uint NumberOfFields;
	CSSM_FIELD* CertFields;
	CSSM_DATA* CertTemplate;
	ulong CCHandle;
	CSSM_DATA* CertTemplateToBeSigned;
	CSSM_CERTGROUP* SignerCertGroup;
	CSSM_TP_VERIFY_CONTEXT* SignerVerifyContext;
	CSSM_TP_VERIFY_CONTEXT_RESULT_PTR SignerVerifyResult;
	CSSM_ENCODED_CRL* CrlToBeVerified;
	CSSM_FIELD* CrlFields;
	CSSM_DATA* OldCrlTemplate;
	CSSM_CERTGROUP* CertGroupToBeRevoked;
	CSSM_CERTGROUP* RevokerCertGroup;
	CSSM_TP_VERIFY_CONTEXT* RevokerVerifyContext;
	CSSM_TP_VERIFY_CONTEXT_RESULT_PTR RevokerVerifyResult;
	uint Reason;
	CSSM_CERTGROUP* CertGroupToBeRemoved;
	CSSM_ENCODED_CRL* CrlToBeSigned;
	CSSM_ENCODED_CRL* CrlToBeApplied;
	CSSM_TP_VERIFY_CONTEXT* ApplyCrlVerifyContext;
	CSSM_DL_DB_LIST* DBList;
	void* ConstructParams;
	CSSM_CERTGROUP* CertGroupFrag;
	CSSM_CERTGROUP* OrderedCertGroup;
	CSSM_TUPLEGROUP* TupleGroup;
	uint PassThroughId;
	void* InputParams;
}

